// ___SETA43  _____
// 25/03/2024 _____
// RADIO  SI4732
// Mando botones  V2 -Terminal
// Arduino 1.8.19
// seta43.duckdns.org
// seta43.blogspot.com


/*
    | BOTONES         |  arduino     |
    | ----------------| -----------  |
    | IZQUIERDA       |     2        |
    | DERECHA         |     3        |
 */
/*
    | Si4732 pin      |  Arduino Pin  |
    | ----------------| ------------  |
    | RESET (pin 9)   |     12        |
    | SDIO (pin 12)   |     A4        |
    | CLK (pin 11)    |     A5        |
*/

char nombre[]="\nSETA43 SI4732";
#define TIMER_B 60
#define BOTON_DOWN  2
#define BOTON_UP 3
/////////////////////////////////////////////////////////////////
//___________OLED_________
#include "olex.h"
#include <Wire.h>
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
#define FRE_MIN 8700
#define FRE_MAX 10800
uint16_t frecuOld,frecuencia=8800;
int iS,iN,iStereo;
/////////////////////////////////////////////////////////////////
#include <SI4735.h>
#define RESET_PIN 12
#define AM_FUNCTION 1
#define FM_FUNCTION 0
SI4735 chipRadio;
/////////////////////////////////////////////////////////////////
#define TAMANO 15
char entrada[TAMANO];
boolean stringComplete = false;
int contador;
/////////////////////////////////////////////////////////////////

char cadena[40];

int t;

void setup() 
{
  Serial.begin(9600);
  while (!Serial) {;}
  Serial.println(nombre);
  pinMode(RESET_PIN, OUTPUT);  
  digitalWrite(RESET_PIN, HIGH);
  delay(200);  
  Wire.begin(); // I2C bus
  scanI2C();
  OleInit();
  delay(200);
  xclearDisplay();  ModeFont=0; xStringAT(0,0,(char *)nombre);
  delay(300); xclearDisplay(); 

  pinMode(BOTON_DOWN, INPUT_PULLUP); 
  pinMode(BOTON_UP, INPUT_PULLUP);
 
  int16_t si4735Addr = chipRadio.getDeviceI2CAddress(RESET_PIN);
  if ( si4735Addr == 0 ) {Serial.println("Si4732 not found!"); while (1) ;} 
  delay(100);
  chipRadio.setup(RESET_PIN, FM_FUNCTION);
  chipRadio.setFM(8400, 10800, frecuencia, 10);  
  chipRadio.setVolume(63); //Sets volume level (0 to 63 max). 
  chipRadio.setRdsConfig(3, 3, 3, 3, 3);
  chipRadio.setFifoCount(1);
  delay(200);
  printFrecuOLED();
  chipRadio.setFrequency(frecuencia);
}


void loop() 
{
    delay(1);
    serieIN();
    t++;     
    if(t>1000)
        {
          t=0;         
          chipRadio.getCurrentReceivedSignalQuality();
          iStereo=chipRadio.getCurrentPilot();
          iN=chipRadio.getCurrentSNR();
          iS=chipRadio.getCurrentRSSI();
          printDataOLED();
          checkRds(); Serial.println();
        }

    if (digitalRead(BOTON_DOWN) == 0) 
        {     
          chipRadio.frequencyDown();
          printFrecuOLED();
          delay(TIMER_B);
          t=0;
        }
    if (digitalRead(BOTON_UP) == 0) 
        {             
          chipRadio.frequencyUp();
          printFrecuOLED();
          delay(TIMER_B);
          t=0;
        }

}

//---------------------------------------------------------------
void printDataOLED(void)
{
  ModeFont=0;
  if(iStereo==0) xStringAT(16,1,"Mono"); else xStringAT(16,1," >< ");
  sprintf(cadena,"SNR:%02u SIG:%02u ",iN,iS); xStringAT(0,5,(char *)cadena);
  Serial.print(cadena);
  sprintf(cadena,"%03d.%02d MHz",frecuencia/100,frecuencia%100);
  Serial.print(cadena);
  if(iStereo==0) Serial.print(" Mono   "); else Serial.print(" Stereo ");
}

void printFrecuOLED(void)
{
  frecuencia=chipRadio.getFrequency();
  ModeFont=2; 
  sprintf(cadena,"%03d.%02d",frecuencia/100,frecuencia%100);
  xStringAT(0,0,(char *)cadena);
  ModeFont=0; xStringAT(12,1,"MHz");
}



void checkRds() 
{
 int z,t;
 char c;
 char *stationName;
 char miSDR[15];
 
  chipRadio.rdsBeginQuery();
  stationName = chipRadio.getRdsStationName();
  z=chipRadio.getNumRdsFifoUsed();
  ModeFont=0; 
  if ( stationName != NULL ) 
  {   
    if(z>2)
      {
        Serial.print(">>");
        for(t=0;t<z && t<12;t++)
        {
          c=*(stationName+t);
          if(c==0 || (c>31 && c<126))  {miSDR[t]=c;}        
          xCaracterAT(t,3, c); 
          Serial.print(c);
        }   
      }
  }
}



//------------SETA43-------------------------------

void serieIN(void)
{
   while (Serial.available())
      {
        char inChar = (char)Serial.read();
        entrada[contador] = inChar;
        if (inChar == 13 || inChar == 10)
          {
            stringComplete = true;
            entrada[contador] = 0;
          }
        if(contador<TAMANO-1) contador++;
      }

  if (stringComplete)
    {
     contador = 0;
     stringComplete = false;
     for(char z=0;z<TAMANO;z++) if(entrada[z]>96 && entrada[z]<123) entrada[z]-=32;  //minúsculas a mayusculas
     Orden(entrada);
    }
}



void Orden(char *bufferS)
{ 
      runFuniones();
}  

void runFuniones(void)
{
 char *val;
 unsigned int valor;
  val=entrada+4;
  if(strstr(entrada,"NEXT") )
      {       
        chipRadio.seekStationUp();
        frecuencia=chipRadio.getFrequency();
         printFrecuOLED();
        goto salir0;
      }
  if(strstr(entrada,"PREV") )
      {       
        chipRadio.seekStationDown();
        frecuencia=chipRadio.getFrequency();
         printFrecuOLED();
        goto salir0;
      }

  if(strstr(entrada,"+++_") )
      {       
        chipRadio.frequencyUp();
        frecuencia=chipRadio.getFrequency();
        printFrecuOLED();
        goto salir0;
      }
  if(strstr(entrada,"---_") )
      {       
        chipRadio.frequencyDown();
        frecuencia=chipRadio.getFrequency();
        printFrecuOLED();
        goto salir0;
      } 
  if(strstr(entrada,"VOL=") )
      {
        valor=atoi(val);
        Serial.print("**volumen="); Serial.println(valor);
        chipRadio.setVolume(valor);
        goto salir0;
      }
  if(strstr(entrada,"FRE=") )
      {
        valor=atoi(val);
        Serial.print("**frecuencia="); Serial.println(valor);
        frecuencia=valor;
        chipRadio.setFrequency(frecuencia);
         printFrecuOLED();       
        goto salir0;
      }
  if(strstr(entrada,"HELP") )
      {        
        Serial.println(F("===========AYUDA==========="));
        Serial.println(F("VOL=[0-63] Volumen"));
        Serial.println(F("FRE=[8400-10800] Frecuencia"));
        Serial.println(F("+++_ o ---_  Sintonia"));
        Serial.println(F("NEXT  o  FREV  Busca emisora"));
        Serial.println(F("============================"));
        goto salir0;
      }

  Serial.println("aERROR ");
salir0:
 ;
}






//=================scanI2C=============
void scanI2C() 
{
 int nDevices = 0;

  Serial.println(F("Scanning..."));
  for (byte address = 1; address < 127; ++address) 
  {
    Wire.beginTransmission(address);
    byte error = Wire.endTransmission();

    if (error == 0) 
      {
            Serial.print(nDevices);
            Serial.print(F("-I2C device found at address 0x"));
            if (address < 16) {   Serial.print("0");  }
            Serial.print(address, HEX); 
            switch(address)
            {
              case 0x11:
                Serial.println(F(" SI473X / SI474X"));
              break;
              case 0x38:
                Serial.println(F(" AHTxx"));
              break;
              case 0x3C:
                Serial.println(F(" OLED"));
              break;
              case 0x50:
                Serial.println(F(" AT24C32"));
              break;
               case 0x68:
                Serial.println(F(" DS1371"));
              break;
               case 0x77:
                Serial.println(F(" BMP280"));
              break;
              default:
              Serial.println(F(" ¿Desconocido?"));
              break;
            }
      
            ++nDevices;
          } 
          else 
            if (error == 4) 
            {
            Serial.print(F("Unknown error at address 0x"));
            if (address < 16) {  Serial.print("0"); }
            Serial.println(address, HEX);
            }
    }
    if (nDevices == 0) 
        {  Serial.println(F("No I2C devices found\n")); } 
      else 
        {  Serial.println(F("done\n"));  }
}
